/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Contents of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.27 - (show annotations) (download)
Tue Oct 27 14:16:49 2009 UTC (4 years, 10 months ago) by scarabeus
Branch: MAIN
Changes since 1.26: +42 -31 lines
Sync cmake-utils and kde eclasses with kde-testing overlays.
Renamed WANT_CMAKE -> CMAKE_REQUIRED in kde eclasses
fixed koffice2.0 support in kde eclasses
Added WANT_CMAKE into cmake-utils eclass, where it brings possibility to depend on cmake only when some useflag is required.
Used with WANT_CMAKE="variable", where variable is the useflag (its autoadded to IUSE too.)

1 # Copyright 1999-2009 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.18 2009/05/09 13:23:15 scarabeus Exp $
4 #
5 # @ECLASS: kde4-meta.eclass
6 # @MAINTAINER:
7 # kde@gentoo.org
8 # @BLURB: Eclass for writing "split" KDE packages.
9 # @DESCRIPTION:
10 # This eclass provides all necessary functions for writing split KDE ebuilds.
11 #
12 # You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13 # Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14
15 inherit kde4-base versionator
16
17 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18
19 if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21 fi
22
23 # Add khelpcenter dependency when installing handbooks
24 if [[ ${PN} != khelpcenter ]] && has handbook ${IUSE//+}; then
25 RDEPEND+=" handbook? ( $(add_kdebase_dep khelpcenter) )"
26 fi
27
28 # Add dependencies that all packages in a certain module share.
29 case ${KMNAME} in
30 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
31 COMMONDEPEND+=" >=kde-base/qimageblitz-0.0.4"
32 ;;
33 kdepim|kdepim-runtime)
34 COMMONDEPEND+="
35 dev-libs/boost
36 $(add_kdebase_dep kdepimlibs)
37 "
38 case ${PN} in
39 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
40 IUSE+=" +kontact"
41 if ! slot_is_at_least 4.4 ${SLOT} || [[ ${SLOT} == 4.4 && ${PV} < 4.3.68 ]]; then
42 RDEPEND+=" kontact? ( $(add_kdebase_dep kontactinterfaces) )"
43 fi
44 ;;
45 esac
46 ;;
47 kdegames)
48 if [[ ${PN} != libkdegames ]]; then
49 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
50 fi
51 ;;
52 koffice)
53 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
54 RDEPEND+="
55 !app-office/${PN}:0
56 !app-office/koffice:0
57 !app-office/koffice-meta:0
58 "
59 if has openexr ${IUSE//+}; then
60 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
61 else
62 COMMONDEPEND+=" media-gfx/imagemagick"
63 fi
64
65 COMMONDEPEND+="
66 dev-cpp/eigen:2
67 media-libs/fontconfig
68 media-libs/freetype:2
69 "
70 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
71 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
72 fi
73 ;;
74 esac
75
76 DEPEND+=" ${COMMONDEPEND}"
77 RDEPEND+=" ${COMMONDEPEND}"
78 unset COMMONDEPEND
79
80 debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
81 debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
82
83 # Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
84 case ${BUILD_TYPE} in
85 live)
86 case ${KMNAME} in
87 extragear*|playground*)
88 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
89 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
90 ;;
91 esac
92 ;;
93 esac
94
95 # @ECLASS-VARIABLE: KMNAME
96 # @DESCRIPTION:
97 # Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
98 # _before_ inheriting this eclass, (unlike the other parameters), since it's
99 # used to set $SRC_URI.
100
101 # @ECLASS-VARIABLE: KMMODULE
102 # @DESCRIPTION:
103 # Specify exactly one subdirectory of $KMNAME here. Defaults to $PN.
104 # The subdirectory listed here is treated exactly like items in $KMEXTRA.
105 #
106 # Example: The ebuild name of "kdebase/l10n" is kde-base/kdebase-l10n, because
107 # just 'l10n' would be too confusing. Hence it sets KMMODULE="l10n".
108
109 # @ECLASS-VARIABLE: KMNOMODULE
110 # @DESCRIPTION:
111 # If set to "true", $KMMODULE doesn't have to be defined.
112 #
113 # Example usage: If you're installing subdirectories of a package, like plugins,
114 # you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
115 # set KMNOMODULE="true".
116 if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then
117 KMMODULE=${PN}
118 fi
119
120 # @ECLASS-VARIABLE: KMEXTRA
121 # @DESCRIPTION:
122 # All subdirectories listed here will be extracted, compiled & installed.
123 # $KMMODULE is always added to $KMEXTRA.
124 # If the handbook USE-flag is set, and if this directory exists,
125 # then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be
126 # handled in the ebuild.
127 # If the documentation is in a different subdirectory, you should add it to KMEXTRA.
128
129 # @ECLASS-VARIABLE: KMCOMPILEONLY
130 # @DESCRIPTION:
131 # All subdirectories listed here will be extracted & compiled, but not installed.
132
133 # TODO: better formulation may be needed
134 # @ECLASS-VARIABLE: KMEXTRACTONLY
135 # @DESCRIPTION:
136 # All subdirectories listed here will be extracted, but neither compiled nor installed.
137 # This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA
138
139 # @ECLASS-VARIABLE: KMTARPARAMS
140 # @DESCRIPTION:
141 # Specify extra parameters to pass to tar, in kde4-meta_src_extract.
142 # '-xpf -j' are passed to tar by default.
143
144 # @FUNCTION: kde4-meta_pkg_setup
145 # @DESCRIPTION:
146 # Currently just calls its equivalent in kde4-base.eclass(5). Use this one in
147 # split ebuilds.
148 kde4-meta_pkg_setup() {
149 debug-print-function ${FUNCNAME} "$@"
150
151 kde4-base_pkg_setup
152 }
153
154 # @FUNCTION: kde4-meta_src_unpack
155 # @DESCRIPTION:
156 # This function unpacks the source for split ebuilds. See also
157 # kde4-meta-src_extract.
158 kde4-meta_src_unpack() {
159 debug-print-function ${FUNCNAME} "$@"
160
161 if [[ ${BUILD_TYPE} = live ]]; then
162 migrate_store_dir
163 S="${WORKDIR}/${P}"
164 mkdir -p "${S}"
165 ESVN_RESTRICT="export" subversion_src_unpack
166 subversion_wc_info
167 subversion_bootstrap
168 kde4-meta_src_extract
169 else
170 kde4-meta_src_extract
171 fi
172 }
173
174 # FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
175
176 # @FUNCTION: kde4-meta_src_extract
177 # @DESCRIPTION:
178 # A function to unpack the source for a split KDE ebuild.
179 # Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
180 # KMTARPARAMS.
181 kde4-meta_src_extract() {
182 debug-print-function ${FUNCNAME} "$@"
183
184 if [[ ${BUILD_TYPE} = live ]]; then
185 local rsync_options subdir kmnamedir targetdir
186 # Export working copy to ${S}
187 einfo "Exporting parts of working copy to ${S}"
188 kde4-meta_create_extractlists
189
190 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/"
191
192 # Copy ${KMNAME} non-recursively (toplevel files)
193 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \
194 || die "${ESVN}: can't export toplevel files to '${S}'."
195 # Copy cmake directory
196 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then
197 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \
198 || die "${ESVN}: can't export cmake files to '${S}'."
199 fi
200 # Copy all subdirectories
201 for subdir in $(__list_needed_subdirectories); do
202 targetdir=""
203 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
204 continue
205 fi
206
207 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
208 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
209 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
210 done
211
212 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
213 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
214 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
215 fi
216 else
217 local abort tarball tarfile f extractlist moduleprefix postfix
218 case ${PV} in
219 4.3.85 | 4.3.9[0568])
220 # block for normally packed upstream unstable snapshots
221 KMTARPARAMS+=" --bzip2" # bz2
222 postfix="bz2"
223 ;;
224 4.3.[6-9]*)
225 KMTARPARAMS+=" --lzma" # lzma
226 postfix="lzma"
227 ;;
228 *)
229 KMTARPARAMS+=" --bzip2" # bz2
230 postfix="bz2"
231 ;;
232 esac
233 case ${KMNAME} in
234 kdebase-apps)
235 # kdebase/apps -> kdebase-apps
236 tarball="kdebase-${PV}.tar.${postfix}"
237 # Go one level deeper for kdebase-apps in tarballs
238 moduleprefix=apps/
239 KMTARPARAMS+=" --transform=s|apps/||"
240 ;;
241 *)
242 # Create tarball name from module name (this is the default)
243 tarball="${KMNAME}-${PV}.tar.${postfix}"
244 ;;
245 esac
246
247 # Full path to source tarball
248 tarfile="${DISTDIR}/${tarball}"
249
250 # Detect real toplevel dir from tarball name - it will be used upon extraction
251 # and in __list_needed_subdirectories
252 topdir="${tarball%.tar.*}/"
253
254 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
255
256 kde4-meta_create_extractlists
257
258 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
259 AUTHORS COPYING INSTALL README NEWS ChangeLog
260 do
261 extractlist+=" ${topdir}${moduleprefix}${f}"
262 done
263 extractlist+=" $(__list_needed_subdirectories)"
264
265 pushd "${WORKDIR}" > /dev/null
266 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
267 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
268
269 # Default $S is based on $P; rename the extracted directory to match $S if necessary
270 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
271
272 popd > /dev/null
273
274 eend $?
275
276 # We need to clear it here to make verification below work
277 unset moduleprefix
278
279 if [[ -n ${KDE4_STRICTER} ]]; then
280 for f in $(__list_needed_subdirectories fatal); do
281 if [[ ! -e "${S}/${f#*/}" ]]; then
282 eerror "'${f#*/}' is missing"
283 abort=true
284 fi
285 done
286 [[ -n ${abort} ]] && die "There were missing files."
287 fi
288
289 # We don't need it anymore
290 unset topdir
291 fi
292 }
293
294 # @FUNCTION: kde4-meta_create_extractlists
295 # @DESCRIPTION:
296 # Create lists of files and subdirectories to extract.
297 # Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
298 # KMEXTRACTONLY and KMTARPARAMS.
299 kde4-meta_create_extractlists() {
300 debug-print-function ${FUNCNAME} "$@"
301
302 # TODO change to KMEXTRA for more strict check
303 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then
304 # We use the basename of $KMMODULE because $KMMODULE can contain
305 # the path to the module subdirectory.
306 KMEXTRA_NONFATAL+="
307 doc/${KMMODULE##*/}"
308 fi
309
310 # Add some CMake-files to KMEXTRACTONLY.
311 # Note that this actually doesn't include KMEXTRA handling.
312 # In those cases you should care to add the relevant files to KMEXTRACTONLY
313 case ${KMNAME} in
314 kdebase)
315 KMEXTRACTONLY+="
316 apps/config-apps.h.cmake
317 apps/ConfigureChecks.cmake"
318 ;;
319 kdebase-apps)
320 KMEXTRACTONLY+="
321 config-apps.h.cmake
322 ConfigureChecks.cmake"
323 ;;
324 kdebase-runtime)
325 KMEXTRACTONLY+="
326 config-runtime.h.cmake"
327 ;;
328 kdebase-workspace)
329 KMEXTRACTONLY+="
330 config-unix.h.cmake
331 ConfigureChecks.cmake
332 config-workspace.h.cmake
333 config-X11.h.cmake
334 startkde.cmake
335 KDE4WorkspaceConfig.cmake.in"
336 ;;
337 kdegames)
338 if [[ ${PN} != libkdegames ]]; then
339 KMEXTRACTONLY+="
340 libkdegames/"
341 fi
342 ;;
343 kdepim)
344 if [[ ${PN} != libkdepim ]]; then
345 KMEXTRACTONLY+="
346 libkdepim/"
347 fi
348 case ${SLOT} in
349 4.3|4.4|live)
350 KMEXTRACTONLY+="
351 kdepim-version.h
352 config-enterprise.h.cmake"
353 ;;
354 esac
355 KMEXTRACTONLY+="
356 kleopatra/ConfigureChecks.cmake"
357 if has kontact ${IUSE//+} && use kontact; then
358 KMEXTRA+="
359 kontact/plugins/${PLUGINNAME:-${PN}}/"
360 if ! slot_is_at_least 4.4 ${SLOT} || [[ ${SLOT} == 4.4 && ${PV} < 4.3.68 ]]; then
361 KMEXTRACTONLY+="
362 kontactinterfaces/"
363 fi
364 fi
365 ;;
366 kdeutils)
367 case ${SLOT} in
368 4.3|4.4|live)
369 KMEXTRACTONLY+="
370 kdeutils-version.h"
371 ;;
372 esac
373 ;;
374 koffice)
375 KMEXTRACTONLY+="
376 config-endian.h.cmake
377 filters/config-filters.h.cmake
378 config-openexr.h.cmake
379 config-opengl.h.cmake
380 config-prefix.h.cmake
381 "
382 case ${PV} in
383 2.0.*)
384 KMEXTRACTONLY+="
385 config-openctl.h.cmake"
386 ;;
387 esac
388 ;;
389 esac
390 # Don't install cmake modules for split ebuilds, to avoid collisions.
391 case ${KMNAME} in
392 kdepim)
393 # No need for unpack since 4.2.86
394 # Remove when 4.2 is wiped out from the tree
395 case ${PV} in
396 4.2.[0-4])
397 KMCOMPILEONLY+="
398 cmake/modules/"
399 ;;
400 esac
401 ;;
402 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
403 case ${PN} in
404 libkdegames|libkdeedu|libkworkspace)
405 KMEXTRA+="
406 cmake/modules/"
407 ;;
408 *)
409 KMCOMPILEONLY+="
410 cmake/modules/"
411 ;;
412 esac
413 ;;
414 esac
415
416 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
417 }
418
419 __list_needed_subdirectories() {
420 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
421
422 # We expand KMEXTRA by adding CMakeLists.txt files
423 kmextra="${KMEXTRA}"
424 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
425 for i in ${kmextra}; do
426 kmextra_expanded+=" ${i}"
427 j=$(dirname ${i})
428 while [[ ${j} != "." ]]; do
429 kmextra_expanded+=" ${j}/CMakeLists.txt";
430 j=$(dirname ${j})
431 done
432 done
433
434 # Expand KMMODULE
435 if [[ -n ${KMMODULE} ]]; then
436 kmmodule_expanded="${KMMODULE}"
437 j=$(dirname ${KMMODULE})
438 while [[ ${j} != "." ]]; do
439 kmmodule_expanded+=" ${j}/CMakeLists.txt";
440 j=$(dirname ${j})
441 done
442 fi
443
444 # Expand KMCOMPILEONLY
445 for i in ${KMCOMPILEONLY}; do
446 kmcompileonly_expanded+=" ${i}"
447 j=$(dirname ${i})
448 while [[ ${j} != "." ]]; do
449 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
450 j=$(dirname ${j})
451 done
452 done
453
454 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
455 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
456 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
457
458 # Create final list of stuff to extract
459 # We append topdir only when specified (usually for tarballs)
460 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
461 ${KMEXTRACTONLY}
462 do
463 extractlist+=" ${topdir}${moduleprefix}${i}"
464 done
465
466 echo ${extractlist}
467 }
468
469 # @FUNCTION: kde4-meta_src_prepare
470 # @DESCRIPTION:
471 # Meta-package build system configuration handling - commenting out targets, etc..
472 kde4-meta_src_prepare() {
473 debug-print-function ${FUNCNAME} "$@"
474
475 kde4-meta_change_cmakelists
476 kde4-base_src_prepare
477 }
478
479 # FIXME: no comment here?
480 _change_cmakelists_parent_dirs() {
481 debug-print-function ${FUNCNAME} "$@"
482
483 local _olddir _dir
484 _dir="${S}"/${1}
485 until [[ ${_dir} == "${S}" ]]; do
486 _olddir=$(basename "${_dir}")
487 _dir=$(dirname "${_dir}")
488 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
489 if [[ -f ${_dir}/CMakeLists.txt ]]; then
490 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
491 -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
492 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
493 fi
494 done
495 }
496
497 # FIXME: add description
498 # @FUNCTION: kde4-meta_change_cmakelists
499 # @DESCRIPTION:
500 kde4-meta_change_cmakelists() {
501 debug-print-function ${FUNCNAME} "$@"
502
503 pushd "${S}" > /dev/null
504
505 comment_all_add_subdirectory ./
506
507 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
508 if [[ -f CMakeLists.txt ]]; then
509 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
510 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
511 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
512 fi
513
514 if [[ -z ${KMNOMODULE} ]]; then
515 # Restore "add_subdirectory" in $KMMODULE subdirectories
516 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
517 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
518 die "${LINENO}: died in KMMODULE section"
519 _change_cmakelists_parent_dirs ${KMMODULE}
520 fi
521
522 local i
523
524 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
525 for i in ${KMEXTRACTONLY}; do
526 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
527 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
528 -i ${i}/../CMakeLists.txt || \
529 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
530 fi
531 done
532
533 # KMCOMPILEONLY
534 for i in ${KMCOMPILEONLY}; do
535 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
536 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
537 find "${S}"/${i} -name CMakeLists.txt -print0 | \
538 xargs -0 sed -i \
539 -e 's/^#DONOTCOMPILE //g' \
540 -e '/install(.*)/{s/^/#DONOTINSTALL /;}' \
541 -e '/^install(/,/)/{s/^/#DONOTINSTALL /;}' \
542 -e '/kde4_install_icons(.*)/{s/^/#DONOTINSTALL /;}' || \
543 die "${LINENO}: sed died in the KMCOMPILEONLY section while processing ${i}"
544 _change_cmakelists_parent_dirs ${i}
545 done
546
547 # KMEXTRA section
548 for i in ${KMEXTRA}; do
549 debug-print "${LINENO}: KMEXTRA section, processing ${i}"
550 find "${S}"/${i} -name CMakeLists.txt -print0 | \
551 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
552 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
553 _change_cmakelists_parent_dirs ${i}
554 done
555 # KMEXTRA_NONFATAL section
556 for i in ${KMEXTRA_NONFATAL}; do
557 if [[ -d "${S}"/${i} ]]; then
558 find "${S}"/${i} -name CMakeLists.txt -print0 | \
559 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
560 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
561 _change_cmakelists_parent_dirs ${i}
562 fi
563 done
564
565 case ${KMNAME} in
566 kdebase-workspace)
567 # COLLISION PROTECT section
568 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
569 # not as a part of every package.
570 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
571 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
572 sed -e '/startkde/s/^/#DONOTINSTALL /' \
573 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
574 fi
575 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
576 if [[ ${PN} != libkworkspace ]]; then
577 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
578 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
579 fi
580 ;;
581 kdebase-runtime)
582 # COLLISION PROTECT section
583 # Only install the kde4 script as part of kde-base/kdebase-data
584 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
585 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
586 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
587 fi
588 ;;
589 kdenetwork)
590 # Disable hardcoded kdepimlibs check
591 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
592 -i CMakeLists.txt || die "failed to disable hardcoded checks"
593 ;;
594 kdepim)
595 case ${PN} in
596 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
597 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
598 -e '/add_custom_target(kmail_xml /,/)/p' \
599 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
600 _change_cmakelists_parent_dirs kmail
601 ;;
602 esac
603 ;;
604 kdewebdev)
605 # Disable hardcoded kdepimlibs check
606 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
607 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
608 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
609 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
610 -i CMakeLists.txt || die "failed to disable hardcoded checks"
611 ;;
612 koffice)
613 # prevent collisions
614 if [[ ${PN} != koffice-data ]]; then
615 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
616 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
617 sed -e '/install(.\+config-openexr\.h.\+)/d' \
618 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
619 fi
620 # koffice 2.0
621 case ${PV} in
622 2.0.[1-9])
623 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
624 "${S}"/CMakeLists.txt || \
625 die "${LINENO}: sed died in collision prevention section"
626 ;;
627 *) ;;
628 esac
629 esac
630
631 popd > /dev/null
632 }
633
634 # @FUNCTION: kde4-meta_src_configure
635 # @DESCRIPTION:
636 # Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
637 # ebuilds.
638 kde4-meta_src_configure() {
639 debug-print-function ${FUNCNAME} "$@"
640
641 # Set some cmake default values here (usually workarounds for automagic deps)
642 case ${KMNAME} in
643 kdewebdev)
644 mycmakeargs="
645 -DWITH_KdepimLibs=OFF
646 -DWITH_LibXml2=OFF
647 -DWITH_LibXslt=OFF
648 -DWITH_Boost=OFF
649 -DWITH_LibTidy=OFF
650 ${mycmakeargs}"
651 ;;
652 esac
653
654 kde4-base_src_configure
655 }
656
657 # @FUNCTION: kde4-meta_src_compile
658 # @DESCRIPTION:
659 # General function for compiling split KDE4 applications.
660 # Overrides kde4-base_src_compile.
661 kde4-meta_src_compile() {
662 debug-print-function ${FUNCNAME} "$@"
663
664 kde4-base_src_compile "$@"
665 }
666
667 # @FUNCTION: kde4-meta_src_test
668 # @DESCRIPTION:
669 # Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
670 # ebuilds.
671 kde4-meta_src_test() {
672 debug-print-function $FUNCNAME "$@"
673
674 kde4-base_src_test
675 }
676
677 # @FUNCTION: kde4-meta_src_install
678 # @DESCRIPTION:
679 # Function for installing KDE4 split applications.
680 kde4-meta_src_install() {
681 debug-print-function $FUNCNAME "$@"
682
683 kde4-base_src_install
684 }
685
686 # @FUNCTION: kde4-meta_src_make_doc
687 # @DESCRIPTION:
688 # This function searches in ${S}/${KMMODULE},
689 # and tries to install "AUTHORS ChangeLog* README* NEWS TODO" if these files exist.
690 kde4-meta_src_make_doc() {
691 debug-print-function ${FUNCNAME} "$@"
692
693 local doc
694 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
695 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
696 done
697
698 kde4-base_src_make_doc
699 }
700
701 # @FUNCTION: kde4-meta_pkg_postinst
702 # @DESCRIPTION:
703 # Display information about application handbook and invoke kbuildsycoca4.
704 kde4-meta_pkg_postinst() {
705 debug-print-function ${FUNCNAME} "$@"
706
707 if has handbook ${IUSE//+} && ! use handbook; then
708 echo
709 einfo "Application handbook for ${PN} has not been installed."
710 einfo "To install handbook, reemerge =${CATEGORY}/${PF} with 'handbook' USE flag."
711 echo
712 fi
713
714 kde4-base_pkg_postinst
715 }
716
717 # @FUNCTION: kde4-meta_pkg_postrm
718 # @DESCRIPTION:
719 # Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
720 # ebuilds.
721 kde4-meta_pkg_postrm() {
722 debug-print-function ${FUNCNAME} "$@"
723
724 kde4-base_pkg_postrm
725 }

  ViewVC Help
Powered by ViewVC 1.1.20